#!/usr/bin/env python

def e(x): pass

class C:
    def h(self):
        self.m = self.f
        return self.m # not known
    def g(self):
        return self.f # C.f with context self
    def f(self): pass
    e = e

    def test(self):
        self.e()
        self.f()
        self.g()
        self.h()

class D:
    e = C.e
    f = C.f
    def g(self):
        return self.f # D.f with context preserved
    def h(self):
        self.m = self.f
        return self.m # not known

    def test(self):
        self.e(1)
        self.f(2)
        self.g()
        self.h()

class E(C):
    def g(self):
        return self.f # C.f with context self
    def h(self):
        self.m = self.f
        return self.m # not known

    def test(self):
        self.e()
        self.f()
        self.g()
        self.h()

C.f
D.f
E.f

c = C()
d = D()
e = E()

x = c.f # bound C.f   == c.h() == c.g()
y = d.f # unbound C.f == d.h() == d.g()
z = e.f # bound E.f   == e.h() == e.g()

p = c.e # bound C.e
q = d.e # unbound C.e
r = e.e # bound E.e

# vim: tabstop=4 expandtab shiftwidth=4
